const moment = require('moment')
const data = require('./data')

function getMZF(dob) {
    var res = {status: 0, message: ''}
    if(!dob) {
        res.message = 'မွေးသက္ကရာဇ်ထည့်သွင်းပေးပါ။'
        return res
    }

    if(!moment(dob).isValid()) {
        res.message = 'မွေးသက္ကရာဇ်မှားယွင်းနေပါသည်။'
        return res
    }

    var current_date = new Date()
    var birth_date = new Date(dob)

    // ဘာနေ့သားလဲ
    var birth_day = birth_date.getDay()
    var day = data.day(birth_day)

    // အသက်ဘယ်လောက်လဲ
    var age = current_date.getFullYear() - birth_date.getFullYear()

    var sr_index = 0;
    var age_start = birth_day + 1 // Sunday is 1 (not 0) to calculate
    var age_end = age_start + 1

    if(age > birth_day) {
        while(age < age_start || age > age_end) {
            age_start += 2
            age_end = age_start + 1
            sr_index = (sr_index === 6) ? 0 : ++sr_index
        }
        // ဘယ်မှာရောက်နေလဲ
        var sr = data.sr(sr_index)

        // ဘယ်နှစ်တွေမှာရောက်နေတာလဲ
        var sr_age = `${age_start}, ${age_end}` // ၂ နှစ်စီဖြစ်၍ - အစနှစ်နှင့် အဆုံးနှစ်ဟုမှတ်ယူသည်။

        // အဖြေဘာထွက်လည်း
        var result = data.result(sr_index)

        age = age.toString()
        Object.keys(data.numbers()).forEach(function (item) {
            const re = new RegExp(data.numbers()[item], "g")
            age = age.replace(re, item)
            sr_age = sr_age.replace(re, item)
        })

        res.data = {day: day, age: age, sr: sr, sr_age: sr_age, result: result}
        res.status = 1
        res.message = 'တွက်ချက်မှုအောင်မြင်ပါသည်။'
    } else {
        res.message = 'တွက်ချက်မှုမအောင်မြင်ပါ။ ဇနကဟောကိန်းနှင့်တွက်နိုင်ရန် အသက်ငယ်နေပါသည်။'
    }
    return res
}

module.exports = getMZF